// MainDlg.h : CMainDlg NX̃C^[tFCX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

//^XNo[{^𗘗pꍇRg͂
//vWindows7SDK
#define USE_TBC 

class CMainDlg : public CDialogImpl<CMainDlg>, public CUpdateUI<CMainDlg>,
		public CMessageFilter, public CIdleHandler, public CWinDataExchange<CMainDlg>
{
public:
	enum { IDD = IDD_MAINDLG };

	CMainDlg()
		: filename(_T(""))
		, closetimer(0)
		, CmdLine(0)
	{
		#ifdef USE_TBC
		g_wmTBC=-1;
		ptl=0;
		#endif
	}

	virtual BOOL PreTranslateMessage(MSG* pMsg)
	{
		return CWindow::IsDialogMessage(pMsg);
	}

	virtual BOOL OnIdle()
	{
		return FALSE;
	}

	BEGIN_UPDATE_UI_MAP(CMainDlg)
	END_UPDATE_UI_MAP()

	BEGIN_DDX_MAP(CMainDlg)
        DDX_CONTROL_HANDLE(IDC_EDIT1, edit1)
        DDX_CONTROL_HANDLE(IDC_PROGRESS1, prog1)
        DDX_CONTROL_HANDLE(IDC_BTN_OPN, button[0])
        DDX_CONTROL_HANDLE(IDC_BTN_PRG, button[1])
        DDX_CONTROL_HANDLE(IDC_BTN_ERS, button[2])
        DDX_CONTROL_HANDLE(IDC_BTN_CLS, button[3])
    END_DDX_MAP()

	BEGIN_MSG_MAP(CMainDlg)
		COMMAND_HANDLER(IDC_BTN_OPN, BN_CLICKED, OnBnClickedBtnOpn)
		COMMAND_HANDLER(IDC_BTN_CLS, BN_CLICKED, OnBnClickedBtnCls)
		MESSAGE_HANDLER(WM_TIMER,OnTimer)
		MESSAGE_HANDLER(WM_DROPFILES,OnDropFiles)
		COMMAND_HANDLER(IDC_BTN_PRG, BN_CLICKED, OnBnClickedBtnPrg)
		COMMAND_HANDLER(IDC_BTN_ERS, BN_CLICKED, OnBnClickedBtnErs)
		#ifdef USE_TBC
		MESSAGE_HANDLER(g_wmTBC,OnTBC)
		COMMAND_HANDLER(1,THBN_CLICKED,OnBnClickedBtnPrg)
		COMMAND_HANDLER(2,THBN_CLICKED,OnBnClickedBtnErs)
		#endif
		//default handler
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
		//COMMAND_ID_HANDLER(IDOK, OnOK)
		COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
	END_MSG_MAP()

	// nh[̃vg^Cv
	//LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	//LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	//LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled)

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		// ʂ̒Sփ_CAOړ
		CenterWindow();

		// ACR̐ݒ
		HICON hIcon = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), 
			IMAGE_ICON, ::GetSystemMetrics(SM_CXICON), ::GetSystemMetrics(SM_CYICON), LR_DEFAULTCOLOR);
		SetIcon(hIcon, TRUE);
		HICON hIconSmall = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), 
			IMAGE_ICON, ::GetSystemMetrics(SM_CXSMICON), ::GetSystemMetrics(SM_CYSMICON), LR_DEFAULTCOLOR);
		SetIcon(hIconSmall, FALSE);

		// bZ[W tB^[щʍXVp̃IuWFNgo^
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		ATLASSERT(pLoop != NULL);
		pLoop->AddMessageFilter(this);
		pLoop->AddIdleHandler(this);

		UIAddChildWindowContainer(m_hWnd);
		
		DoDataExchange(FALSE);

		Initialize();

		return TRUE;
	}

	LRESULT OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		// bZ[W tB^[щʍXVp̃IuWFNgo^
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		ATLASSERT(pLoop != NULL);
		pLoop->RemoveMessageFilter(this);
		pLoop->RemoveIdleHandler(this);

		return 0;
	}

//	LRESULT OnOK(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
//	{
//		// TODO: `FbNR[h̒ǉ
//		CloseDialog(wID);
//		return 0;
//	}

	LRESULT OnCancel(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		CloseDialog(wID);
		return 0;
	}

	void CloseDialog(int nVal)
	{
		DestroyWindow();
		::PostQuitMessage(nVal);
	}
	LRESULT OnBnClickedBtnOpn(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnBnClickedBtnCls(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	void Initialize();
	#ifdef USE_TBC
	DWORD g_wmTBC;
	ITaskbarList3* ptl;
	LRESULT OnTBC(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	#endif
	CString filename;
	int closetimer;
	int CmdLine;
	LRESULT OnTimer(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnDropFiles(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	CEdit edit1;
	CProgressBarCtrl prog1;
	LRESULT OnBnClickedBtnPrg(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnBnClickedBtnErs(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	void Progress(int);
	CButton button[4];
};
